CON

'      Standard clock mode * crystal frequency = 80 MHz  
                _clkmode = xtal1 + pll16x                                               
                _xinfreq = 5_000_000

          
'    EEPROM Pins        
                     SCL = 28
                     SDA = 29

'    Convience Aliases        
                   Input = 0
                  Output = 1
                      On = 1
                     Off = 0
                     One = 1
                    Zero = 0
                  Closed = 0
                    Open = 1

'    Normal Delay Times
                      C1 = 300       '5 Minutes
                      C2 = 600       '10 Minutes
                      C3 = 900       '15 Minutes
                      C4 = 1_800     '30 Minutes
                 

'    OverRide Delay Times
                      L1 = 3_600       '1 Hour
                      L2 = 7_200       '2 Hours
                      L3 = 14_440      '4 Hours
                      L4 = 28_880      '8 Hours 
                    

'    EEPROM Addys
            Normal_Addy  = $7000
            Delayed_Addy = $7010


VAR
         
         
            long   Normal, Delayed
         
         
OBJ
         
            eeprom : "Propeller Eeprom"  
              term : "Parallax Serial Terminal"  

         
PUB         Init

            Term.start(57600)

            waitcnt(clkfreq *4 + cnt)     'Wait to allow you to open debug window
            
             Load_Default_Times            'Fetch from EEPROM Normal and Delayed Variables
             
       
            
            

PRI  Backup_Normal                                  
                                              
         eeprom.FromRam(@Normal, @Normal+3, Normal_Addy)


PRI  Backup_Delayed
  
         eeprom.FromRam(@Delayed, @Delayed+3, Delayed_Addy)


PRI  Load_Default_Times                                       
                                                 
         eeprom.ToRam(@Normal, @Normal+3, Normal_Addy)
         eeprom.ToRam(@Delayed, @Delayed+3,Delayed_Addy)
         
         term.dec(normal)              'Display "Normal"
         term.chars(4,4)               'Create a gap on display
         term.dec(delayed)             'Display "Delayed"
         term.char(13)
            
         if Normal == Zero
            Normal := C1
            Backup_Normal
            Delayed := L1
            Backup_Delayed

